/*
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
*/

#include <stdio.h>
#include <nuon/bios.h>
#include <nuon/nise.h>
#include <nuon/joystick.h>

#include "Defines.h"
#include "Game.h"
#include "System.h"

// RasterSoft sprite index
int	gRasterSoftSprite;
int	Sprite_case;

char sall				= 0; 
char sScore				= 1; 
char sready				= 2; 
char shand 				= 3; 

int	RIGHT_EMP_1 = 0 , RIGHT_EMP_2 = 0, RIGHT_EMP_3 = 0, RIGHT_EMP_4 = 0;
int	LEFT_EMP_1 = 0 , LEFT_EMP_2 = 0 , LEFT_EMP_3 = 0, LEFT_EMP_4 = 0;
int	UP_EMP_1 = 0 , UP_EMP_2 = 0 , UP_EMP_3 = 0, UP_EMP_4 = 0;
int	DOWN_EMP_1 = 0 , DOWN_EMP_2 = 0, DOWN_EMP_3 = 0, DOWN_EMP_4 = 0;

int	SPR_RIGHT_EMP_1 , SPR_RIGHT_EMP_2 , SPR_RIGHT_EMP_3 , SPR_RIGHT_EMP_4 ;
int	SPR_LEFT_EMP_1 , SPR_LEFT_EMP_2 , SPR_LEFT_EMP_3 , SPR_LEFT_EMP_4 ;
int	SPR_UP_EMP_1 , SPR_UP_EMP_2 , SPR_UP_EMP_3 , SPR_UP_EMP_4 ;
int	SPR_DOWN_EMP_1 , SPR_DOWN_EMP_2 , SPR_DOWN_EMP_3 , SPR_DOWN_EMP_4 ;

int Score_0 , Score_1 , Score_2 , Score_3 , Score_4 , Score_5, Score_6;
int Lives_spr , Time_0 , Time_1 , Time_2;
int Sprite_ready , spr_hand;


// Alien position
int	CaseX;
int	CaseY;
int Case_pos;
int Case_COLOR = 1;

int reload = 0;
int gamemo = 0;
int frame_gamemo = 0;
int good = 1;

int lives = 3;
int score = 0;

int gamemode = 0;
char score_showed[7] , conv_time[4];
int rtime , lowtime = 10;
int go_time = 0;

int choosey = 160 , choose_menu = 0;
char background_image = 0;

char up_state = 0 , up_time = 0;
char down_state = 0 , down_time = 0;
char left_state = 0 , left_time = 0;
char right_state = 0 , right_time = 0;

char up_on = 0, down_on = 0, left_on = 0, right_on = 0;


extern short Sample1[];
extern short Sample2[];
extern short Sample4[];

int voice1, voice2, voice3, voice4;
PCMPOS Pan;

typedef struct
{
	short			compression;
	short			channels;
	long			samplerate;
	long			bytes_per_second;
	short			block_alignment;
	short   		bits_per_sample;

} __attribute__ ((packed)) WAVE_Format;


typedef struct
{
	short			exponent;
	long			mantissa[2];

} __attribute__ ((packed)) ieeeDoubleFP80;


typedef struct
{
	short			channels;
	long			sample_frames;	
	short   		bits_per_sample;
	ieeeDoubleFP80	samplerate;
	long			compression;

} __attribute__ ((packed)) COMM_Chunk;


bool InitializeGame()
{
	background_image = 0;
	
	CaseX	= 141;
	CaseY 	= 117;
	
	add_allsprites();
	
    AUDIOInit();

    Pan.PCMPanLR = 0;
    Pan.PCMPanFB = 0;
    Pan.PCMPanUD = 0;
	
	return	true;
}

bool GameLoop()
{
	controls_buttons();
	
	switch(gamemode){
		case 0:
			Control_title();
		break;
		
		case 1:
			ShowCase();
			if (gamemo == 0) MoveCase();
			ShowEMPTY();
		break;
	}

	UpdateDisplay(background_image);
	
	return	false;
}

void Control_title(){
	SetSpritePosition(spr_hand, 130, choosey);
	SetSpriteFrame(spr_hand, 0);
	SetSpriteVisible(spr_hand, true);
	
	if (up_state == 1) {
		choose_menu = 0;
		choosey = 160;
	}
	
	if (down_state == 1) {
		choose_menu = 1;
		choosey = 185;
	}
	
	if ( ( ButtonA(_Controller[1]) || ButtonCRight(_Controller[1]) ) && choose_menu == 0) {
		RESET_EVERYTHING();
		notvisible_allsprites();
		setvisible_ingame();
		background_image = 1;
		gamemode = 1;
		reload = 200;
	}
}

void ShowCase()
{
	SetSpritePosition(Sprite_case, CaseX+28+17, CaseY+8+12);
	
	if (gamemo == 2){
		SetSpriteFrame(Sprite_case, 18-4);
		
		go_time++;
		if (go_time > 120) goback_titlescreen();
	}
	else if (gamemo == 1){
	SetSpriteFrame(Sprite_case, 17-4);
		
		if (frame_gamemo > 35){
		gamemo = 0;
		frame_gamemo = 0;
		}
		else{	
		frame_gamemo++;
		}

		
	}	
	else if (gamemo == 0){
	SetSpriteFrame(Sprite_case, Case_pos);
	}
	
}

void ShowEMPTY()
{
	rtime = reload;
	
	conv_time[0] = (rtime / 100) % 10;
	conv_time[1] = (rtime / 10) % 10;
	conv_time[2] = rtime % 10;
	
	if (rtime < 33) lowtime = 10;
	else lowtime = 0;

	SetSpritePosition(Score_0, 49+28, 6+8);
	SetSpritePosition(Score_1, 49+12+28, 6+8);
	SetSpritePosition(Score_2, 49+24+28, 6+8);
	SetSpritePosition(Score_3, 49+36+28, 6+8);
	SetSpritePosition(Score_4, 49+48+28, 6+8);
	SetSpritePosition(Score_5, 49+60+28, 6+8);
	SetSpritePosition(Score_6, 49+72+28, 6+8);
	
	SetSpritePosition(Time_0, 180+28, 6+8);
	SetSpritePosition(Time_1, 180+12+28, 6+8);
	SetSpritePosition(Time_2, 180+24+28, 6+8);
	
	SetSpritePosition(Lives_spr, 272+28, 6+8);
	
	SetSpritePosition(Sprite_ready, 111+72, 120);
	if (reload > 100) SetSpriteVisible(Sprite_ready, true);
	else SetSpriteVisible(Sprite_ready, false);

	SetSpriteFrame(Score_0, score_showed[0]);
	SetSpriteFrame(Score_1, score_showed[1]);
	SetSpriteFrame(Score_2, score_showed[2]);
	SetSpriteFrame(Score_3, score_showed[3]);
	SetSpriteFrame(Score_4, score_showed[4]);
	SetSpriteFrame(Score_5, score_showed[5]);
	SetSpriteFrame(Score_6, score_showed[6]);
	
	SetSpriteFrame(Lives_spr, lives);
	SetSpriteFrame(Time_0, conv_time[0]+lowtime);
	SetSpriteFrame(Time_1, conv_time[1]+lowtime);
	SetSpriteFrame(Time_2, conv_time[2]+lowtime);
	
	SetSpritePosition(SPR_LEFT_EMP_1, 77+28+17, 117+8+12);
	SetSpritePosition(SPR_LEFT_EMP_2, 77+28+17, 117+8+12);
	SetSpritePosition(SPR_LEFT_EMP_3, 77+28+17, 117+8+12);
	SetSpritePosition(SPR_LEFT_EMP_4, 77+28+17, 117+8+12);
	
	SetSpritePosition(SPR_RIGHT_EMP_1, 205+28+17, 117+8+12);
	SetSpritePosition(SPR_RIGHT_EMP_2, 205+28+17, 117+8+12);
	SetSpritePosition(SPR_RIGHT_EMP_3, 205+28+17, 117+8+12);
	SetSpritePosition(SPR_RIGHT_EMP_4, 205+28+17, 117+8+12);
	
	SetSpritePosition(SPR_UP_EMP_1, 141+28+17, 53+8+12);
	SetSpritePosition(SPR_UP_EMP_2, 141+28+17, 53+8+12);
	SetSpritePosition(SPR_UP_EMP_3, 141+28+17, 53+8+12);
	SetSpritePosition(SPR_UP_EMP_4, 141+28+17, 53+8+12);
	
	SetSpritePosition(SPR_DOWN_EMP_1, 141+28+17, 181+8+12);
	SetSpritePosition(SPR_DOWN_EMP_2, 141+28+17, 181+8+12);
	SetSpritePosition(SPR_DOWN_EMP_3, 141+28+17, 181+8+12);
	SetSpritePosition(SPR_DOWN_EMP_4, 141+28+17, 181+8+12);
	
	SetSpriteFrame(SPR_LEFT_EMP_1, LEFT_EMP_1);
	SetSpriteFrame(SPR_LEFT_EMP_2, LEFT_EMP_2);
	SetSpriteFrame(SPR_LEFT_EMP_3, LEFT_EMP_3);
	SetSpriteFrame(SPR_LEFT_EMP_4, LEFT_EMP_4);
	
	SetSpriteFrame(SPR_RIGHT_EMP_1, RIGHT_EMP_1);
	SetSpriteFrame(SPR_RIGHT_EMP_2, RIGHT_EMP_2);
	SetSpriteFrame(SPR_RIGHT_EMP_3, RIGHT_EMP_3);
	SetSpriteFrame(SPR_RIGHT_EMP_4, RIGHT_EMP_4);
	
	SetSpriteFrame(SPR_UP_EMP_1, UP_EMP_1);
	SetSpriteFrame(SPR_UP_EMP_2, UP_EMP_2);
	SetSpriteFrame(SPR_UP_EMP_3, UP_EMP_3);
	SetSpriteFrame(SPR_UP_EMP_4, UP_EMP_4);
	
	SetSpriteFrame(SPR_DOWN_EMP_1, DOWN_EMP_1);
	SetSpriteFrame(SPR_DOWN_EMP_2, DOWN_EMP_2);
	SetSpriteFrame(SPR_DOWN_EMP_3, DOWN_EMP_3);
	SetSpriteFrame(SPR_DOWN_EMP_4, DOWN_EMP_4);
}

void MoveCase()
{	
	reload--;
	
	if (reload < 1){ // Player lose a live after 100 millisecond
		lose_a_life();
		reset_case();	
	}

	
	if (reload < 101){
		if (up_state == 1)
		{
		
		if ((Case_pos == 1 || Case_pos == 5 || Case_pos == 9 || Case_pos == 13)){
			if (UP_EMP_1 == 0){
			good_gfx();
			UP_EMP_1 = Case_pos;
			}
			else if (UP_EMP_1 > 0) {
			lose_a_life();
			}
		}	
		else if ((Case_pos == 2 || Case_pos == 6 || Case_pos == 10 || Case_pos == 14)){
			if (UP_EMP_2 == 0){
			good_gfx();
			UP_EMP_2 = Case_pos;
			}
			else if (UP_EMP_2 > 0){
			lose_a_life();
			}
		}	
		else if((Case_pos == 3 || Case_pos == 7 || Case_pos == 11 || Case_pos == 15)){
			if (UP_EMP_3 == 0){
			good_gfx();
			UP_EMP_3 = Case_pos;
			}
			else if (UP_EMP_3 > 0){
			lose_a_life();
			}
		}
		else if ((Case_pos == 4 || Case_pos == 8 || Case_pos == 12 || Case_pos == 16)){
			if (UP_EMP_4 == 0){
			good_gfx();
			UP_EMP_4 = Case_pos;
			}
			else if (UP_EMP_4 > 0){
			lose_a_life();
			}
		}	
			
			if (UP_EMP_1 > 0 && UP_EMP_2 > 0 && UP_EMP_3 > 0 && UP_EMP_4 > 0){
			UP_EMP_1 = 0;
			UP_EMP_2 = 0;
			UP_EMP_3 = 0;
			UP_EMP_4 = 0;
				if (UP_EMP_1 < 6 && UP_EMP_2 < 6 && UP_EMP_3 < 6 && UP_EMP_4 < 6) score = score + 300;
				else if (UP_EMP_1 == 6 && UP_EMP_2 == 7 && UP_EMP_3 == 8 && UP_EMP_4 == 9)  score = score + 300;
				else if (UP_EMP_1 == 10 && UP_EMP_2 == 11 && UP_EMP_3 == 12 && UP_EMP_4 == 13) score = score + 300;
				else if (UP_EMP_1 == 13 && UP_EMP_2 == 14 && UP_EMP_3 == 15 && UP_EMP_4 == 16) score = score + 300;
				else score = score + 40; 
				calcul_score();
			}
				
			reset_case();
		}
		
		if (down_state == 1)
		{
		
		if ((Case_pos == 1 || Case_pos == 5 || Case_pos == 9 || Case_pos == 13)){
			if (DOWN_EMP_1 == 0){
			good_gfx();
			DOWN_EMP_1 = Case_pos;
			}
			else if (DOWN_EMP_1 > 0) {
			lose_a_life();
			}
		}	
		else if ((Case_pos == 2 || Case_pos == 6 || Case_pos == 10 || Case_pos == 14)){
			if (DOWN_EMP_2 == 0){
			good_gfx();
			DOWN_EMP_2 = Case_pos;
			}
			else if (DOWN_EMP_2 > 0){
			lose_a_life();
			}
		}	
		else if((Case_pos == 3 || Case_pos == 7 || Case_pos == 11 || Case_pos == 15)){
			if (DOWN_EMP_3 == 0){
			good_gfx();
			DOWN_EMP_3 = Case_pos;
			}
			else if (DOWN_EMP_3 > 0){
			lose_a_life();
			}
		}
		else if ((Case_pos == 4 || Case_pos == 8 || Case_pos == 12 || Case_pos == 16)){
			if (DOWN_EMP_4 == 0){
			good_gfx();
			DOWN_EMP_4 = Case_pos;
			}
			else if (DOWN_EMP_4 > 0){
			lose_a_life();
			}
		}	
			
			if (DOWN_EMP_1 > 0 && DOWN_EMP_2 > 0 && DOWN_EMP_3 > 0 && DOWN_EMP_4 > 0){
			DOWN_EMP_1 = 0;
			DOWN_EMP_2 = 0;
			DOWN_EMP_3 = 0;
			DOWN_EMP_4 = 0;
				if (DOWN_EMP_1 < 6 && DOWN_EMP_2 < 6 && DOWN_EMP_3 < 6 && DOWN_EMP_4 < 6) score = score + 300;
				else if (DOWN_EMP_1 == 6 && DOWN_EMP_2 == 7 && DOWN_EMP_3 == 8 && DOWN_EMP_4 == 9)  score = score + 300;
				else if (DOWN_EMP_1 == 10 && DOWN_EMP_2 == 11 && DOWN_EMP_3 == 12 && DOWN_EMP_4 == 13) score = score + 300;
				else if (DOWN_EMP_1 == 13 && DOWN_EMP_2 == 14 && DOWN_EMP_3 == 15 && DOWN_EMP_4 == 16) score = score + 300;
				else score = score + 40; 
				calcul_score();
			}
				
			reset_case();
		}
		
		if (left_state == 1)
		{
		
		if ((Case_pos == 1 || Case_pos == 5 || Case_pos == 9 || Case_pos == 13)){
			if (LEFT_EMP_1 == 0){
			good_gfx();
			LEFT_EMP_1 = Case_pos;
			}
			else if (LEFT_EMP_1 > 0) {
			lose_a_life();
			}
		}	
		else if ((Case_pos == 2 || Case_pos == 6 || Case_pos == 10 || Case_pos == 14)){
			if (LEFT_EMP_2 == 0){
			good_gfx();
			LEFT_EMP_2 = Case_pos;
			}
			else if (LEFT_EMP_2 > 0){
			lose_a_life();
			}
		}	
		else if((Case_pos == 3 || Case_pos == 7 || Case_pos == 11 || Case_pos == 15)){
			if (LEFT_EMP_3 == 0){
			good_gfx();
			LEFT_EMP_3 = Case_pos;
			}
			else if (LEFT_EMP_3 > 0){
			lose_a_life();
			}
		}
		else if ((Case_pos == 4 || Case_pos == 8 || Case_pos == 12 || Case_pos == 16)){
			if (LEFT_EMP_4 == 0){
			good_gfx();
			LEFT_EMP_4 = Case_pos;
			}
			else if (LEFT_EMP_4 > 0){
			lose_a_life();
			}
		}	
			
			if (LEFT_EMP_1 > 0 && LEFT_EMP_2 > 0 && LEFT_EMP_3 > 0 && LEFT_EMP_4 > 0){
			LEFT_EMP_1 = 0;
			LEFT_EMP_2 = 0;
			LEFT_EMP_3 = 0;
			LEFT_EMP_4 = 0;
				if (LEFT_EMP_1 < 6 && LEFT_EMP_2 < 6 && LEFT_EMP_3 < 6 && LEFT_EMP_4 < 6) score = score + 300;
				else if (LEFT_EMP_1 == 6 && LEFT_EMP_2 == 7 && LEFT_EMP_3 == 8 && LEFT_EMP_4 == 9)  score = score + 300;
				else if (LEFT_EMP_1 == 10 && LEFT_EMP_2 == 11 && LEFT_EMP_3 == 12 && LEFT_EMP_4 == 13) score = score + 300;
				else if (LEFT_EMP_1 == 13 && LEFT_EMP_2 == 14 && LEFT_EMP_3 == 15 && LEFT_EMP_4 == 16) score = score + 300;
				else score = score + 40; 
				calcul_score();
			}
				
			reset_case();
		}
		
		if (right_state == 1)
		{
		
		if ((Case_pos == 1 || Case_pos == 5 || Case_pos == 9 || Case_pos == 13)){
			if (RIGHT_EMP_1 == 0){
			good_gfx();
			RIGHT_EMP_1 = Case_pos;
			}
			else if (RIGHT_EMP_1 > 0) {
			lose_a_life();
			}
		}	
		else if ((Case_pos == 2 || Case_pos == 6 || Case_pos == 10 || Case_pos == 14)){
			if (RIGHT_EMP_2 == 0){
			good_gfx();
			RIGHT_EMP_2 = Case_pos;
			}
			else if (RIGHT_EMP_2 > 0){
			lose_a_life();
			}
		}	
		else if((Case_pos == 3 || Case_pos == 7 || Case_pos == 11 || Case_pos == 15)){
			if (RIGHT_EMP_3 == 0){
			good_gfx();
			RIGHT_EMP_3 = Case_pos;
			}
			else if (RIGHT_EMP_3 > 0){
			lose_a_life();
			}
		}
		else if ((Case_pos == 4 || Case_pos == 8 || Case_pos == 12 || Case_pos == 16)){
			if (RIGHT_EMP_4 == 0){
			good_gfx();
			RIGHT_EMP_4 = Case_pos;
			}
			else if (RIGHT_EMP_4 > 0){
			lose_a_life();
			}
		}	
				
				if (RIGHT_EMP_1 > 0 && RIGHT_EMP_2 > 0 && RIGHT_EMP_3 > 0 && RIGHT_EMP_4 > 0){
				RIGHT_EMP_1 = 0;
				RIGHT_EMP_2 = 0;
				RIGHT_EMP_3 = 0;
				RIGHT_EMP_4 = 0;
				if (RIGHT_EMP_1 < 6 && RIGHT_EMP_2 < 6 && RIGHT_EMP_3 < 6 && RIGHT_EMP_4 < 6) score = score + 300;
				else if (RIGHT_EMP_1 == 6 && RIGHT_EMP_2 == 7 && RIGHT_EMP_3 == 8 && RIGHT_EMP_4 == 9)  score = score + 300; 
				else if (RIGHT_EMP_1 == 10 && RIGHT_EMP_2 == 11 && RIGHT_EMP_3 == 12 && RIGHT_EMP_4 == 13) score = score + 300;
				else if (RIGHT_EMP_1 == 13 && RIGHT_EMP_2 == 14 && RIGHT_EMP_3 == 15 && RIGHT_EMP_4 == 16) score = score + 300;
				else score = score + 40; 
				calcul_score();
				}
				
			reset_case();	
			
		}
	}

}

void controls_buttons(){
	
	// MIGHT BE USEFUL TO SUPPORT BOTH THE REMOTE AND THE GAMEPADS
	if (ButtonUp(_Controller[1]) || ButtonCUp(_Controller[1])){ up_on = 1;}
	else{ up_on = 0;}
	if (ButtonDown(_Controller[1]) || ButtonCDown(_Controller[1])){ down_on = 1;}
	else{ down_on = 0;}
	if (ButtonLeft(_Controller[1]) || ButtonCLeft(_Controller[1])){ left_on = 1;}
	else{ left_on = 0;}
	if (ButtonRight(_Controller[1]) || ButtonCRight(_Controller[1])){ right_on = 1;}
	else{ right_on = 0;}
	
	// RELEASED AND JUST PRESSED FOR D-PAD
	// UP
	if (up_state == 0){
		if (up_on==1){
			up_state = 1;
			up_time = 0;
		}
	}
	else if (up_state == 1){
	up_time = up_time + 1;
		if (up_time > 1){
			up_state = 2;
			up_time = 0;
		}
	}
	else if (up_state == 2){
		if (up_on==1) {}
		else{ up_state = 3;}
	}
	else if (up_state == 3){
	up_time = up_time + 1;
		if (up_time > 1){
			up_state = 0;
			up_time = 0;
		}
	}
	
	
	// DOWN
	if (down_state == 0){
		if (down_on==1){
			down_state = 1;
			down_time = 0;
		}
	}
	else if (down_state == 1){
	down_time = down_time + 1;
		if (down_time > 1){
			down_state = 2;
			down_time = 0;
		}
	}
	else if (down_state == 2){
		if (down_on==1) {}
		else{ down_state = 3;}
	}
	else if (down_state == 3){
	down_time = down_time + 1;
		if (down_time > 1){
			up_state = 0;
			down_state = 0;
		}
	}

	// LEFT
	if (left_state == 0){
		if (left_on==1){
			left_state = 1;
			left_time = 0;
		}
	}
	else if (left_state == 1){
	left_time = left_time + 1;
		if (left_time > 1){
			left_state = 2;
			left_time = 0;
		}
	}
	else if (left_state == 2){
		if (left_on==1) {}
		else{ left_state = 3;}
	}
	else if (left_state == 3){
	left_time = left_time + 1;
		if (left_time > 1){
			up_state = 0;
			left_state = 0;
		}
	}
	
	
	// RIGHT
	if (right_state == 0){
		if (right_on==1){
			right_state = 1;
			right_time = 0;
		}
	}
	else if (right_state == 1){
	right_time = right_time + 1;
		if (right_time > 1){
			right_state = 2;
			right_time = 0;
		}
	}
	else if (right_state == 2){
		if (right_on==1) {}
		else{ right_state = 3;}
	}
	else if (right_state == 3){
	right_time = right_time + 1;
		if (right_time > 1){
			up_state = 0;
			right_state = 0;
		}
	}
	
}


void good_gfx(){
	voice1 = PlayWAV((void *)Sample1, -1, &Pan, 0x40000000, 0x40000000 );
}

void gameover_tune(){
	voice2 = PlayWAV((void *)Sample2, -1, &Pan, 0x40000000, 0x40000000 );
}

void miss_gfx(){
	voice4 = PlayWAV((void *)Sample4, -1, &Pan, 0x40000000, 0x40000000 );
}


void RESET_EVERYTHING(){
	reload = 0;
	gamemo = 0;
	frame_gamemo = 0;
	good = 1;
	go_time = 0;
	lives = 3;
	score = 0;
	score_showed[0] = 0;
	score_showed[1] = 0;
	score_showed[2] = 0;
	score_showed[3] = 0;
	score_showed[4] = 0;
	score_showed[5] = 0;
	score_showed[6] = 0;
	gamemode = 1;
	rtime = 0;
	lowtime = 10;
	RIGHT_EMP_1 = 0; 
	RIGHT_EMP_2 = 0; 
	RIGHT_EMP_3 = 0; 
	RIGHT_EMP_4 = 0;
	LEFT_EMP_1 = 0;
	LEFT_EMP_2 = 0; 
	LEFT_EMP_3 = 0;
	LEFT_EMP_4 = 0;
	UP_EMP_1 = 0;
	UP_EMP_2 = 0;
	UP_EMP_3 = 0; 
	UP_EMP_4 = 0;
	DOWN_EMP_1 = 0; 
	DOWN_EMP_2 = 0; 
	DOWN_EMP_3 = 0;
	DOWN_EMP_4 = 0;
	Case_pos = rand_a_b(1,12);
	
	up_state = 0;
	down_state = 0;
	left_state = 0;
	right_state = 0;
	up_time = 0;
	down_time = 0;
	left_time = 0;
	right_time = 0;
}

bool reset_case(){ //Generate a random number
			good = 1;
			
			while (good){
			Case_pos = rand_a_b(1,12);
				if (UP_EMP_1 > 0 && RIGHT_EMP_1 > 0 && LEFT_EMP_1 > 0 && DOWN_EMP_1 && (Case_pos == 1 || Case_pos == 5 || Case_pos == 9 || Case_pos == 13)) good = 1;
				else if (UP_EMP_2 > 0 && RIGHT_EMP_2 > 0 && LEFT_EMP_2 > 0 && DOWN_EMP_2 && (Case_pos == 2 || Case_pos == 6 || Case_pos == 10 || Case_pos == 14)) good = 1;
				else if (UP_EMP_3 > 0 && RIGHT_EMP_3 > 0 && LEFT_EMP_3 > 0 && DOWN_EMP_3 && (Case_pos == 3 || Case_pos == 7 || Case_pos == 11 || Case_pos == 15)) good = 1;
				else if (UP_EMP_4 > 0 && RIGHT_EMP_4 > 0 && LEFT_EMP_4 > 0 && DOWN_EMP_4 && (Case_pos == 4 || Case_pos == 8 || Case_pos == 12 || Case_pos == 16)) good = 1;
				else {
				good = 0;
				}
			}
			
			if (Case_pos > 0 && Case_pos < 5) Case_COLOR = 1;
			else if (Case_pos > 4 && Case_pos < 9) Case_COLOR = 2;
			else if (Case_pos > 8 && Case_pos < 13) Case_COLOR = 3;
			else if (Case_pos > 12 && Case_pos < 17) Case_COLOR = 4;
			reload = 100;
			frame_gamemo = 0;
			
			up_state = 2;
			down_state = 2;
			left_state = 2;
			right_state = 2;
			up_time = 0;
			down_time = 0;
			left_time = 0;
			right_time = 0;
return true;
}

void lose_a_life(){
	    lives = lives - 1;
			if (lives < 1) {
			gameover_tune();
			gamemo = 2;
			}
			else {
			miss_gfx();
			gamemo = 1;
			}
}

void add_allsprites(){
	Sprite_case	= AddSprite(sall, 48, 40);
	SPR_RIGHT_EMP_1 = AddSprite(sall, 48, 40);
	SPR_RIGHT_EMP_2 = AddSprite(sall, 48, 40);
	SPR_RIGHT_EMP_3 = AddSprite(sall, 48, 40);
	SPR_RIGHT_EMP_4 = AddSprite(sall, 48, 40);
	
	SPR_LEFT_EMP_1 = AddSprite(sall, 48, 40);
	SPR_LEFT_EMP_2 = AddSprite(sall, 48, 40);
	SPR_LEFT_EMP_3 = AddSprite(sall, 48, 40);
	SPR_LEFT_EMP_4 = AddSprite(sall, 48, 40);
	
	SPR_UP_EMP_1 = AddSprite(sall, 48, 40);
	SPR_UP_EMP_2 = AddSprite(sall, 48, 40);
	SPR_UP_EMP_3 = AddSprite(sall, 48, 40);
	SPR_UP_EMP_4 = AddSprite(sall, 48, 40);
	
	SPR_DOWN_EMP_1 = AddSprite(sall, 48, 40);
	SPR_DOWN_EMP_2 = AddSprite(sall, 48, 40);
	SPR_DOWN_EMP_3 = AddSprite(sall, 48, 40);
	SPR_DOWN_EMP_4 = AddSprite(sall, 48, 40);
		
	Score_0	= AddSprite(sScore, 16, 16);
	Score_1	= AddSprite(sScore, 16, 16);
	Score_2	= AddSprite(sScore, 16, 16);
	Score_3	= AddSprite(sScore, 16, 16);
	Score_4	= AddSprite(sScore, 16, 16);
	Score_5	= AddSprite(sScore, 16, 16);
	Score_6	= AddSprite(sScore, 16, 16);
	
	Lives_spr = AddSprite(sScore, 16, 16);
	
	Time_0	= AddSprite(sScore, 16, 16);
	Time_1	= AddSprite(sScore, 16, 16);
	Time_2	= AddSprite(sScore, 16, 16);
	
	Sprite_ready	= AddSprite(sready, 96, 32);
	spr_hand	= AddSprite(shand, 32, 32);
}

void setvisible_ingame(){
	SetSpriteVisible(Sprite_case, true);
	
	SetSpriteVisible(Score_0, true);
	SetSpriteVisible(Score_1, true);
	SetSpriteVisible(Score_2, true);
	SetSpriteVisible(Score_3, true);
	SetSpriteVisible(Score_4, true);
	SetSpriteVisible(Score_5, true);
	SetSpriteVisible(Score_6, true);
	
	SetSpriteVisible(Lives_spr, true);
	SetSpriteVisible(Time_0, true);
	SetSpriteVisible(Time_1, true);
	SetSpriteVisible(Time_2, true);
	
	SetSpriteVisible(SPR_LEFT_EMP_1, true);
	SetSpriteVisible(SPR_LEFT_EMP_2, true);
	SetSpriteVisible(SPR_LEFT_EMP_3, true);
	SetSpriteVisible(SPR_LEFT_EMP_4, true);
	
	SetSpriteVisible(SPR_RIGHT_EMP_1, true);
	SetSpriteVisible(SPR_RIGHT_EMP_2, true);
	SetSpriteVisible(SPR_RIGHT_EMP_3, true);
	SetSpriteVisible(SPR_RIGHT_EMP_4, true);
	
	SetSpriteVisible(SPR_UP_EMP_1, true);
	SetSpriteVisible(SPR_UP_EMP_2, true);
	SetSpriteVisible(SPR_UP_EMP_3, true);
	SetSpriteVisible(SPR_UP_EMP_4, true);
	
	SetSpriteVisible(SPR_DOWN_EMP_1, true);
	SetSpriteVisible(SPR_DOWN_EMP_2, true);
	SetSpriteVisible(SPR_DOWN_EMP_3, true);
	SetSpriteVisible(SPR_DOWN_EMP_4, true);
}

void notvisible_allsprites(){
	SetSpriteVisible(Sprite_case, false);	
	SetSpriteVisible(SPR_LEFT_EMP_1, false);
	SetSpriteVisible(SPR_LEFT_EMP_2, false);
	SetSpriteVisible(SPR_LEFT_EMP_3, false);
	SetSpriteVisible(SPR_LEFT_EMP_4, false);
	
	SetSpriteVisible(SPR_RIGHT_EMP_1, false);
	SetSpriteVisible(SPR_RIGHT_EMP_2, false);
	SetSpriteVisible(SPR_RIGHT_EMP_3, false);
	SetSpriteVisible(SPR_RIGHT_EMP_4, false);
	
	SetSpriteVisible(SPR_UP_EMP_1, false);
	SetSpriteVisible(SPR_UP_EMP_2, false);
	SetSpriteVisible(SPR_UP_EMP_3, false);
	SetSpriteVisible(SPR_UP_EMP_4, false);
	
	SetSpriteVisible(SPR_DOWN_EMP_1, false);
	SetSpriteVisible(SPR_DOWN_EMP_2, false);
	SetSpriteVisible(SPR_DOWN_EMP_3, false);
	SetSpriteVisible(SPR_DOWN_EMP_4, false);

	SetSpriteVisible(Score_0, false);
	SetSpriteVisible(Score_1, false);
	SetSpriteVisible(Score_2, false);
	SetSpriteVisible(Score_3, false);
	SetSpriteVisible(Score_4, false);
	SetSpriteVisible(Score_5, false);
	SetSpriteVisible(Score_6, false);
	
	SetSpriteVisible(spr_hand, false);
	
	SetSpriteVisible(Lives_spr, false);
	SetSpriteVisible(Time_0, false);
	SetSpriteVisible(Time_1, false);
	SetSpriteVisible(Time_2, false);
}

void calcul_score(){
	score_showed[0] = (score / 1000000) % 10;
	score_showed[1] = (score / 100000) % 10;
	score_showed[2] = (score / 10000) % 10;
	score_showed[3] = (score / 1000) % 10;
	score_showed[4] = (score / 100) % 10;
	score_showed[5] = (score / 10) % 10;
	score_showed[6] = score % 10;
}

// Used for random coordinate for the clouds
int rand_a_b(int a, int b){
    return rand()%(b-a) +a;
}

void goback_titlescreen(){
	notvisible_allsprites();
	background_image = 0;
	gamemode = 0;
}















static inline long GetLong( void *l )
{
unsigned short *s;

	s = (unsigned short *)l;

	return (s[0] << 16) | s[1];
}


static inline void SwapEndian32(long *l)
{
unsigned char *c, c0, c1;

	c = (unsigned char *)l;
	c0 = c[0];
	
	c[0] = c[3];
	c1 = c[1];
	c[1] = c[2];
	c[2] = c1;
	c[3] = c0;
}


static inline void SwapEndian16(short *l)
{
unsigned char *c, c0, c1;

	c = (unsigned char *)l;
	c0 = c[0];
	c1 = c[1];

	c[0] = c1;
	c[1] = c0;
}

int WaveToNWave(void *wavaddr)
{
WAVE_Format *wav;
long *l;
short *pcm;
long pcm_length;
char *x;
int frequency, i, num_samples;
long *endfile;

	// We assume that "wavaddr" is long aligned here...
	l = (long *)wavaddr;

	// We don't bother verifying that this is a RIFF/WAVE file
	// since that should have been the test that sent us here.

	// Convert overall filesize & save it for loop testing
	SwapEndian32(&l[1]);
	endfile = (long *)((long)wavaddr + l[1]);
	
	// We could step past chunks looking for "fmt " but let's not.
	if( l[3] != 0x666d7420 )			// If the "fmt " chunk doesn't happen
		return(-1);						// here, we're screwed.


	// WAVE header would ordinarily start at the 5th longword
	wav = (WAVE_Format *)&l[5];

	// Convert all header fields from Little Endian to Big Endian
	SwapEndian16(&wav->compression);
	SwapEndian16(&wav->channels);
	SwapEndian32(&wav->samplerate);
	SwapEndian32(&wav->bytes_per_second);
	SwapEndian16(&wav->block_alignment);
	SwapEndian16(&wav->bits_per_sample);

// Once we've done that, then test the header information to make sure
// we don't have a sample format we can't handle anyway.  Note that if 
// the WAVE is rejected by this test, the header is partially
// converted already.  We could undo that, but it doesn't seem necessary.

	if( wav->compression != 1 )			// PCM compression all we can do
		return(-2);

	if( wav->bits_per_sample != 16 )	// We can only do 16-bit samples
		return(-3);

	if( wav->channels > 1 )				// We can only do MONO samples
		return(-4);	

// Calculate NUON sample rate value.  0x1000 = 24000

	frequency = (wav->samplerate * 0x1000) / 24000;

	if( frequency > 0x10000 )			// Make sure sample rate isn't too high.
		return(-5);						// We only can go to about 1 million samples/sec.
										// Yes, that was a joke.

	// Set RIFF header to indicate that we've already converted everything
	// Do this AFTER verifying that the WAVE format is acceptible.
	
	l[2] = 0x4E574156;					// Change "WAVE" to "NWAV"

// OK, now we've gotten the header figured out, let's
// locate and convert the actual sample data.
	
	x = (char *)wavaddr + 20;			// Skip to just past "fmt " chunkname
    
	SwapEndian32(&l[4]);				// Convert chunksize value
    x += l[4];							// Add size of "fmt " chunk
    l = (long *)x;						// Reset pointer to what should be "data" chunk
	
	// OK, now we should be be pointing at the "data" chunk.
	// If the chunk at "x" is not "data" then it might be one of
	// the extended information chunks we mentioned earlier, as
	// those frequently happen before the data chunk.
	// So skip past each chunk until we find "data"
	
	while( GetLong(l) != 0x64617461 && (l < endfile) )	// Is it the "data" chunk?
	{
		SwapEndian32(&l[1]);			// byte-swap chunk size
		
		x = (char *)l;					// Not data chunk so
		x += 4;							// step past chunk name,
        x += GetLong(&l[1]);			// add size of chunk,
		l = (long *)x;					// And reset pointer to next chunk.
	} 
	
	// Make sure we found "data" and didn't walk off the end
	if( *l != 0x64617461 )				// If not "data"
		return(-1);						// then unsupported format

	SwapEndian32(&l[1]);				// Convert size of data chunk

	pcm_length = l[1];					// Get size of "data" chunk
	pcm = (short *)&l[2];				// Get address of data
	num_samples = pcm_length / 2;		// Get number of samples

// Let us now convert the actual sample data

	for( i = 0; i < num_samples; i++ )
		SwapEndian16(pcm++);

	return(0);
}

int PlayWAV(void *wavaddr, int voice, PCMPOS *Pan, int volume, int echo )
{
long *l, *pcm, pcm_length;
char *x;
int frequency;
WAVE_Format *wav;
PCMHEAD WaveDefine;
int result;
long *endfile;

	l = (long *)wavaddr;

	// Verify data as a WAV file
	if( l[0] != 0x52494646 )			// "RIFF"
		return(-1);

	// Get overall filesize & save it for loop testing
	endfile = (long *)((long)wavaddr + l[1]);
	
	if( l[2] != 0x57415645 && l[2] != 0x4E574156 )	// "WAVE" or "NWAV"
		return(-1);
	
// See if the sample has already been converted from little-endian
// to big endian format, and if not, then go convert it right now!

	if( l[2] != 0x4E574156 )			// If not "NWAV"
	{
		result = WaveToNWave(wavaddr);	// Go byte-swap from INTEL format
		
		if( result )					// Conversion will return non-zero 
			return(-2);					// if it's a format we don't like

		// Note that if the WAVE is rejected, the header may be partially
		// converted already.
	}

	
	// We presume that the "fmt " chunk starts at l[3] and that this
	// has been previously verified by WaveToNWave().
	// We could step past chunks looking for "fmt " but let's not.

	
	// Get sample rate out of WAVE header.
	// We've already determined in WaveToNWave() that the WAVE format
	// is OK, so we don't need to check most WAVE header info again.

	wav = (WAVE_Format *)&l[5];
	frequency = (wav->samplerate * 0x1000) / 24000;


	x = (char *)wavaddr + 20;			// Skip to "fmt " chunk
	x += l[4];							// Add size of "fmt " chunk
	l = (long *)x;						// Reset pointer to what should be "data" chunk
	
	// If the chunk at "x" is not "data" then it might be one of
	// the extended information chunks we mentioned earlier, as
	// those frequently happen before the data chunk.
	
	while( GetLong(l) != 0x64617461 && (l < endfile) )	// Is it the "data" chunk?
	{
		x = (char *)l;					// Not data chunk so
		x += 4;							// step past chunk name,
		x += GetLong(&l[1]);			// add size of chunk,
		l = (long *)x;					// And reset pointer to next chunk.
	} 
    
	if( GetLong(l) != 0x64617461 )		// If not "data"
		return(-2);						// then unsupported format

	pcm_length = l[1];					// Get size of "data" chunk
	pcm = &l[2];						// Get address of data
    
	// OK, everything we did earlier was simply to get to the right location
	// for the data, and to figure out what the sample rate value should be.
    
	WaveDefine.PCMWaveBegin = (unsigned long)pcm;
    WaveDefine.PCMLength    = pcm_length / 2;
    WaveDefine.PCMLoopBegin = 0;
    WaveDefine.PCMLoopEnd   = pcm_length / 2;
    WaveDefine.PCMBaseFreq  = frequency;
    WaveDefine.PCMControl   = 0;

	return PCMPlaySample(voice, &WaveDefine, Pan, volume, echo );
}
